//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TBC_Sample_Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TBARCODE9Lib_OCX"
#pragma link "TBarCode9Lib_OCX"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::txtBCDataChange(TObject *Sender)
{
  TBC->Text  = txtBCData->Text;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
  if (ComboBox1->Text == "Code-39")
  {
    EnterText->Caption    = "ENTER TEXT IN CAPS...";
    txtBCData->Text       = "HELLO WORLD";
    TBC->BarCode  = eBC_3OF9;
  }
  else if (ComboBox1->Text == "Code-128")
  {
    EnterText->Caption    = "Enter any text you want...";
    TBC->BarCode  = eBC_Code128;
  }
  else if (ComboBox1->Text == "EAN13")
  {
    EnterText->Caption    = "Enter 12 digits";
    txtBCData->Text       = "123456789012";
    TBC->BarCode  = eBC_EAN13;
  }
  else if (ComboBox1->Text == "UPCA")
  {
    EnterText->Caption    = "Enter 11 digits";
    txtBCData->Text       = "12345678901";
    TBC->BarCode  = eBC_UPCA;
  }
  else if (ComboBox1->Text == "Code-2of5")
  {
    EnterText->Caption    = "Enter numerical data";
    txtBCData->Text       = "12345";
    TBC->BarCode  = eBC_2OF5;
  }
  else if (ComboBox1->Text == "PDF417")
  {
    EnterText->Caption    = "Enter your data:";
    txtBCData->Text       = "Encode ASCII and more...";
    TBC->BarCode  = eBC_PDF417;
  }
  else if (ComboBox1->Text == "Data Matrix")
  {
    EnterText->Caption    = "Enter your data:";
    txtBCData->Text       = "Encode large amount of data...";
    TBC->BarCode   = eBC_DataMatrix;
  }
  else if (ComboBox1->Text == "QR-Code")
  {
    EnterText->Caption    = "Enter your data:";
    txtBCData->Text       = "Quick readable with high capacity...";
    TBC->BarCode   = eBC_QRCode;
  }
  else if (ComboBox1->Text == "RSS-14 CC-Auto")
  {
    EnterText->Caption    = "Enter your data:";
    txtBCData->Text       = "1234567890123|composite data";
    TBC->BarCode   = eBC_RSS14;
  }
  else
  {
    EnterText->Caption    = "TEC-IT Barcode Tools...";
    txtBCData->Text       = "supporting all common bar codes and more...";
    TBC->BarCode   = eBC_MicroPDF417;
  }
  
  if (ComboBox1->Text == "RSS-14 CC-Auto")
    TBC->CompositeComponent = eCC_Auto;
  else
    TBC->CompositeComponent = eCC_None;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveButton1Click(TObject *Sender)
{
  long nXSize;
  long nYSize;

  // SaveImage wants dimensions in Pixel
  // to avoid matrix effects, we adapt the XSize and YSize
  // to the number of bar/space elements in the symbol

  switch ( TBC->BarCode ) {
  case eBC_QRCode :
  case eBC_DataMatrix :
        nXSize = int (2 * TBC->CountModules / TBC->CountRows);
        nYSize = int (2 * TBC->CountRows);
        break;
  case eBC_PDF417 :
        nXSize = int (TBC->CountModules / TBC->CountRows);
        nYSize = int (5 * TBC->CountRows);
        break;
  case eBC_MicroPDF417 :
        nXSize = int (2 * TBC->CountModules / TBC->CountRows);
        nYSize = int (5 * TBC->CountRows);
        break;
  case eBC_RSS14 :
        nXSize = int (TBC->Get2DXCols());
        nYSize = int (TBC->Get2DXRows());
        nYSize = nYSize + TBC->GetTextAreaHeightImg (eMUPixel);
        break;
  default :
        nXSize = int (2 * TBC->CountModules);
        nYSize = 150;
}

  TBC->SaveImage ((WideString)"C:\\TECIT.BMP", eIMBmp, nXSize, nYSize, 72 , 72);
}

void __fastcall TForm1::OnClick_chkOptPixel(TObject *Sender)
{
        // If you have a problem with readableness and output resolution
        // use this property (and contact our free support!)

        TBC->OptResolution = chkOptPixel->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LicenseAtStartup(TObject *Sender)
{
// you can order your license key directly from http://www.tec-it.com/order/
// the key in this code sample is for demo use and invalid!

String sLicensee = "Mem: Licensee String";    // Licensee (Mem: is added for Developer licenses only)
long nBufSizeLic = sLicensee.WideCharBufSize();
long nLengthLic  = sLicensee.Length();
wchar_t*wcLicensee = new wchar_t[ nLengthLic + 1 ];

String sKey      = "00112233";     // License Key String
long nBufSizeKey = sKey.WideCharBufSize();
long nLengthKey  = sKey.Length();
wchar_t*wcKey    = new wchar_t[ nLengthKey + 1 ];

    sLicensee.WideChar(wcLicensee, nBufSizeLic); // convert to widechar*
    sKey.WideChar(wcKey, nBufSizeKey);

    // apply the licence key at startup of your application
    if (this->TBC)
        this->TBC->LicenseMe(wcLicensee, eLicKindDeveloper, 1, wcKey, eLicProd1D); // license the control

    // to check if key was used/entered correctly (for debugging only):
    // this->TBC->Licensing();

    delete []wcLicensee;  // always free memory and avoid memory leaks!
    delete []wcKey;

}
//---------------------------------------------------------------------------

